using Bp.Sync.BackEnd.Infrastructure.Repositories;
using Bp.Sync.Domain.Elastics.Inventories.Configurations;
using Bp.Sync.Dto.Results;
using CommonLibrary;
using Dapper;
using EasyNetQ;
using MediatR;
using Microsoft.Extensions.Configuration;
using System;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Application.Commands.Inventories.Configurations
{
    public class SyncContractDiscountLevelHandler : IRequestHandler<SyncContractDiscountLevelCommand, BaseResult>
    {
        private readonly IDbConnection _dbConnection;
        private readonly IContractDiscountLevelRepository _ContractDiscountLevelRepository;
        private readonly IBus _bus;

        public SyncContractDiscountLevelHandler(IConfiguration configuration, IContractDiscountLevelRepository ContractDiscountLevelRepository, IBus bus)
        {
            var connectionString = configuration.GetConnectionString("InventoryConnection");
            _dbConnection = new SqlConnection(connectionString);
            _ContractDiscountLevelRepository = ContractDiscountLevelRepository;
            _bus = bus;
        }

        public async Task<BaseResult> Handle(SyncContractDiscountLevelCommand request, CancellationToken cancellationToken)
        {
            var rs = new BaseResult();

            if (request.Ids.Count() > 1000)
            {
                var length = request.Ids.Count();
                if (length > 0)
                {
                    for (int i = 0; i <= length / 1000; i++)
                    {
                        if (length > i * 1000)
                        {
                            var ids = request.Ids.Skip(i * 1000).Take(1000).ToList();
                            if (ids.Count() > 0)
                            {
                                await _bus.SendAsync($"SyncToElasticContractDiscountLevel", ids.ConvertListLongToString());
                            }
                        }
                    }
                }
                return new BaseResult { Result = Result.Success, Message = $"sent {length} ContractDiscountLevels" };
            }

            if (!request.Ids.Any())
            {
                rs.Message = $"no data to update";
                rs.Result = Dto.Results.Result.Success;
                return rs;
            }
            try
            {
                var p = new Dto.DapperTypes.IdsParam(request.Ids);
                var items = await _dbConnection.QueryAsync<ContractDiscountLevelElastic>("Sync_ContractDiscountLevel_Get_By_List_Id", p, commandType: CommandType.StoredProcedure);
                if (items.Any())
                {
                    var rs2 = await _ContractDiscountLevelRepository.AddManyAsync(items);
                    if (rs2.Result == Result.Success)
                    {
                        await _dbConnection.ExecuteAsync("Synced_ContractDiscountLevel_By_List_Id", p, commandType: CommandType.StoredProcedure);
                        rs.Message = $"{items.Count()} synced";
                        rs.Result = Result.Success;
                    }
                    else
                    {
                        rs.Message = $"can not insert db";
                        rs.Result = Result.Success;
                    }
                }
                else
                {
                    rs.Message = $"no data to update";
                    rs.Result = Result.Success;
                }
            }
            catch (Exception ex)
            {
                rs.Message = ex.Message.ToString();
                rs.Result = Result.SystemError;
            }
            return rs;
        }
    }
}